﻿@page "/ProyectosMud"
<PageTitle>Listado de Usuarios</PageTitle>

@using System.Text.RegularExpressions
@using System.ComponentModel.DataAnnotations

@using System.Net.Http.Json
@using MudBlazor

@using Hackaton.Shared


@inject HttpClient httpClient
@inject ISnackbar Snackbar

@inject NavigationManager _navManager



<MudButton Href="/Proyectos/agregar/0"
           Variant="Variant.Filled"
           EndIcon="@Icons.Material.Filled.AddCircle"
           Color="Color.Primary" Class="mb-2">
    Agregar proyecto
</MudButton>

<MudTable Items="@ProyectoDTOs" Dense="@dense" Hover="@hover" ReadOnly="false" CanCancelEdit="@canCancelEdit" Filter="new Func<Proyecto,bool>(FilterFunc)"
          @bind-SelectedItem="selectedItem1" SortLabel="Ordenar por" EditTrigger="TableEditTrigger.EditButton">
    <ToolBarContent>
        <MudText Typo="Typo.h6">Listado de Proyectos</MudText>
        <MudSpacer />
        <MudTextField @bind-Value="searchString" Placeholder="Buscar" Adornment="Adornment.Start" AdornmentIcon="@Icons.Material.Filled.Search" IconSize="Size.Medium" Class="mt-0"></MudTextField>
    </ToolBarContent>
    <ColGroup>
        <col style="width:50px;" />
        <col />
        <col />
        <col style="width:50px;" />
        <col style="width:150px;" />
    </ColGroup>
    <HeaderContent>
        <MudTh>Info</MudTh>
        <MudTh><MudTableSortLabel InitialDirection="SortDirection.Ascending" SortBy="new Func<Proyecto, object>(x=>x.IdProyecto)">ID</MudTableSortLabel></MudTh>
        <MudTh><MudTableSortLabel SortBy="new Func<Proyecto, object>(x=>x.Nombre)">Nombre</MudTableSortLabel></MudTh>
        <MudTh><MudTableSortLabel SortBy="new Func<Proyecto, object>(x=>x.Descripcion)">Descripción</MudTableSortLabel></MudTh>
        <MudTh>Acciones</MudTh>
    </HeaderContent>
    <RowTemplate>
        <MudTd><MudIconButton Size="@Size.Small" Icon="@Icons.Material.Outlined.Info" Class="pa-0" Href=@($"/Tareas/{context.IdProyecto}") /></MudTd>
        <MudTd DataLabel="ID">@context.IdProyecto</MudTd>
        <MudTd DataLabel="Nombre">@context.Nombre</MudTd>
        <MudTd DataLabel="Descripción">@context.Descripcion</MudTd>
        <MudTd>
            <MudIconButton Size="@Size.Small" Icon="@Icons.Material.Outlined.Edit" Class="pa-0" OnClick="() => ModificarProyecto(context.IdProyecto)" />
            <MudIconButton Size="@Size.Small" Icon="@Icons.Material.Outlined.Delete" Class="pa-0" OnClick="() => EliminarProyecto(context.IdProyecto)" />
        </MudTd>

    </RowTemplate>

    <PagerContent>
        <MudTablePager />
    </PagerContent>
</MudTable>

<MudSwitch @bind-Checked="@dense" Color="Color.Secondary">Dense</MudSwitch>

@code {
    private List<string> editEvents = new();
    private bool dense = false;
    private bool hover = true;
    private bool ronly = false;
    private bool canCancelEdit = false;
    private bool blockSwitch = false;
    private string searchString = "";
    private Proyecto selectedItem1 = null;

    private IEnumerable<Proyecto> ProyectoDTOs = new List<Proyecto>();

    // protected override async Task OnInitializedAsync()
    // {
    //     try
    //     {
    //         ProyectoDTOs = await _proyectoServicio.ListarProyectos();
    //     }
    //     catch
    //     {
    //         Snackbar.Add("No se logró obtener los proyectos", Severity.Error);
    //     }
    // }

    private bool FilterFunc(Proyecto proyectoDTO)
    {
        if (string.IsNullOrWhiteSpace(searchString))
            return true;
        if (proyectoDTO.Nombre.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        if (proyectoDTO.IdProyecto.ToString().Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        return false;
    }

    private void ModificarProyecto(int id)
    {
        _navManager.NavigateTo($"/Proyectos/modificar/{id}");
    }

    private void EliminarProyecto(int id)
    {
        _navManager.NavigateTo($"/Proyectos/eliminar/{id}");
    }
}